import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/2_Buttons/2_Impact_Button_2.dart';
import 'package:impact/4_TextFields/1_Ready_TF/1_Impact_Email_TF.dart';
import 'package:impact/4_TextFields/1_Ready_TF/2_Impact_Pass_TF.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/1_Global_TF_Decoration.dart';


class ImpactFormSignIn1 extends StatefulWidget {
  Widget? BackDisplay;
  String? SignInTxt,ForgetPassTxt;
  TFDecoration? TFDecor;
  TextEditingController? EmailTFCtrl,PassTFCtrl;
  Function? SignInDo,ForgetPassDo,RegisterDo;

  ImpactFormSignIn1({
    this.BackDisplay,
    this.SignInTxt,
    this.TFDecor,
    this.EmailTFCtrl,
    this.PassTFCtrl,
    this.SignInDo,
    this.ForgetPassDo,
    this.RegisterDo,
  });

  @override
  State<StatefulWidget> createState() {
     return ImpactFormSignIn1State();
  }
}

class ImpactFormSignIn1State extends State<ImpactFormSignIn1> {
  GlobalKey<FormState> formKey = new GlobalKey<FormState>();

  @override
  Widget build(BuildContext context) {
    return Container(
      width :MediaQuery.of(context).size.width,
      height:MediaQuery.of(context).size.height,
      child:Stack(
        children: [

          (this.widget.BackDisplay==null)?SizedBox():this.widget.BackDisplay!,

          SingleChildScrollView(
            child:Center(
              child: Padding(
                padding: const EdgeInsets.only(
                    left:20,
                    right:20
                ),
                child: Form(
                  key:formKey,
                  child: Column(
                    mainAxisAlignment:MainAxisAlignment.center,
                    children: [
                      SizedBox(height:MediaQuery.of(context).size.height*0.35,),

                      ImpactEmailTF(
                        TFDecor:this.widget.TFDecor,
                        TFCtrl:(this.widget.EmailTFCtrl!=null)?this.widget.EmailTFCtrl:TextEditingController(),
                      ),
                      SizedBox(height:10,),

                      ImpactPassTF(
                        TFDecor:this.widget.TFDecor,
                        TFCtrl:(this.widget.PassTFCtrl!=null)?this.widget.PassTFCtrl:TextEditingController(),
                      ),
                      Align(
                        alignment:(ImpactSelectedLang=="English")?Alignment.centerRight:Alignment.centerLeft,
                        child:TextButton(
                          child:Text(
                              (this.widget.ForgetPassTxt==null)?ImpactLang["ForgotPass"]:this.widget.ForgetPassTxt,
                              style:TextStyle(
                               color:ImpactPrimaryColor
                              ),
                          ),
                          onPressed:(){
                             print("~~~~~~~~~~~~~Impact Forget Pass Clicked~~~~~~~~~~~~~~~~");
                             if(this.widget.ForgetPassDo!=null){
                               this.widget.ForgetPassDo!.call();
                             }
                          },
                        ),
                      ),

                      Padding(
                        padding: const EdgeInsets.all(8.0),
                        child: ImpactButton2(
                          Txt:(this.widget.SignInTxt==null)?ImpactLang["Login"]:this.widget.SignInTxt,
                          Do:(){
                            print("~~~~~~~~~~~~Impact SignIn Clicked~~~~~~~~~~~~~~~");
                            if(formKey.currentState!.validate()){
                              print("~~~~~~~~~~~~Impact SignIn Form Validated~~~~~~~~~~~~~~~");
                              this.widget.SignInDo!.call();
                            }
                            else {
                              print("~~~~~~~~~~~~Impact SignIn Form Not Validated~~~~~~~~~~~~~~~");
                            }
                          },
                          W:MediaQuery.of(context).size.width,
                          H:40.0,
                        ),
                      ),

                      SizedBox(
                        height:MediaQuery.of(context).size.width*0.091,
                      ),

                      (ImpactSelectedLang=="English")?Row(
                        mainAxisAlignment:MainAxisAlignment.center,
                        children: [
                          Text(
                            ImpactLang["Dont_Have_Acc"]
                          ),
                          TextButton(
                            child:Text(
                                ImpactLang["Register"],
                                style:TextStyle(
                                  color:ImpactPrimaryColor
                                ),
                            ),
                            onPressed:(){
                              print("~~~~~~~Impact Register Clicked~~~~~~~~");
                              if(this.widget.RegisterDo!=null){
                                this.widget.RegisterDo!.call();
                              }
                            },
                          )
                        ],
                      ):Row(
                        mainAxisAlignment:MainAxisAlignment.center,
                        children: [

                          TextButton(
                            child:Text(
                                ImpactLang["Register"],
                                style:TextStyle(
                                  color:ImpactPrimaryColor
                                ),
                            ),
                            onPressed:(){
                              print("~~~~~~~Impact Register Clicked~~~~~~~~");
                              if(this.widget.RegisterDo!=null){
                                this.widget.RegisterDo!.call();
                              }
                            },
                          ),
                          Text(
                              ImpactLang["Dont_Have_Acc"]
                          ),

                        ],
                      )


                    ],
                  ),
                ),
              ),
            ),
          ),


        ],
      )
    );
  }

}