import 'package:flutter/material.dart';
import 'package:impact/0_Impact_Global/2_Shared_Preference.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/1_Global_TF_Decoration.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/2_Impact_TFDecoration_1.dart';
import 'package:impact/4_TextFields/2_TF_Decoration/3_Impact_TFDecoration_2.dart';


class ImpactPassTF extends StatefulWidget {
  TextEditingController? TFCtrl;
  String? HintTextEmpty,HintTextWrong,HintText;
  TextDirection? TxtDirection;
  var OnChangeDo;
  bool? TFEnabled;
  TFDecoration? TFDecor;
  bool? ShowIcon;
  Widget? PrefixIcon;
  Color? BoxIcClr;


  ImpactPassTF({
    this.TFCtrl,
    this.HintTextEmpty,
    this.HintTextWrong,
    this.TxtDirection,
    this.OnChangeDo,
    this.TFEnabled,
    this.HintText,
    this.TFDecor,
    this.ShowIcon,
    this.PrefixIcon,
    this.BoxIcClr,
  });

  @override
  State<StatefulWidget> createState() {
    return ImpactPassTFState();
  }
}

class ImpactPassTFState extends State<ImpactPassTF> {

  bool ObscurePass = true;


  @override
  Widget build(BuildContext context) {
    return Directionality(
      textDirection:(this.widget.TxtDirection!=null)?this.widget.TxtDirection!:ImpactTxtDirection,
      child: Stack(
        children: [

          TextFormField(
            obscureText:ObscurePass,
            controller:(this.widget.TFCtrl==null)?TextEditingController():this.widget.TFCtrl,
            textDirection:(this.widget.TxtDirection==null)?ImpactTxtDirection:this.widget.TxtDirection,
            onChanged:(this.widget.OnChangeDo!=null)?this.widget.OnChangeDo:(value){},
            enabled:(this.widget.TFEnabled!=null)?this.widget.TFEnabled:true,
            validator:(value){
              if(value!.isEmpty){
                return (this.widget.HintTextEmpty!=null)?this.widget.HintTextEmpty:ImpactLang["Passw_Empty_Descr"];
              }
            },
            decoration:(this.widget.TFDecor==null)?InputDecoration():

            (this.widget.TFDecor!.index==0)?ReturnTFDecoration1(
                (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Password"],
                this.widget.ShowIcon,
                this.widget.PrefixIcon,
                "Password"
            ):


            (this.widget.TFDecor!.index==1)?ReturnTFDecoration2(
                (this.widget.HintText!=null)?this.widget.HintText:ImpactLang["Password"],
                this.widget.ShowIcon,
                this.widget.PrefixIcon,
                "Password",
                this.widget.BoxIcClr
            ):


            InputDecoration(),
          ),

          Align(
            alignment:(ImpactSelectedLang=="English")?Alignment.centerRight:Alignment.centerLeft,
            child: IconButton(
              icon:Icon(
                  (ObscurePass==true)?Icons.remove_red_eye:Icons.remove_red_eye_outlined
              ),
              onPressed:(){
                setState((){
                  this.ObscurePass=!this.ObscurePass;
                });
              },
            ),
          )


        ],
      )
    );
  }

}